VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Simple I/O  -- Portal API Sample Code"
   ClientHeight    =   2775
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4890
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2775
   ScaleWidth      =   4890
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   " Read Port 2: "
      Height          =   1215
      Left            =   758
      TabIndex        =   4
      Top             =   1440
      Width           =   3375
      Begin VB.CommandButton btnRead 
         Caption         =   "Read"
         Height          =   375
         Left            =   2280
         TabIndex        =   2
         Top             =   480
         Width           =   975
      End
      Begin VB.Label lblInValue 
         BorderStyle     =   1  'Fixed Single
         Height          =   300
         Left            =   960
         TabIndex        =   7
         Top             =   480
         Width           =   1095
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         Caption         =   "Value:"
         Height          =   255
         Left            =   135
         TabIndex        =   6
         Top             =   480
         Width           =   735
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Write to Port 1: "
      Height          =   1215
      Left            =   758
      TabIndex        =   3
      Top             =   120
      Width           =   3375
      Begin VB.CommandButton btnWrite 
         Caption         =   "Write"
         Height          =   375
         Left            =   2280
         TabIndex        =   1
         Top             =   480
         Width           =   975
      End
      Begin VB.TextBox txtOutValue 
         Height          =   300
         Left            =   960
         TabIndex        =   0
         Top             =   480
         Width           =   1095
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Value:"
         Height          =   255
         Left            =   135
         TabIndex        =   5
         Top             =   480
         Width           =   735
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit     'Require all variables to be dimensioned

   'Dimension form-level variables
    Dim hCard As Long       'Holds the handle to the CRD155B
   
Private Sub btnRead_Click()
  'Dimension variables
   Dim Value As Long            'Holds the value read in from the input port
   Dim Result As Long           'Holds the return value of the function
   
  'Read the input port
   Result = we_InputValue(hCard, 2, Value)
  
  'Check if any errors occurred
   If Result < 0 Then
      'Error handling code goes here; we will just display the error number if an
      ' error occurs.  If we wanted to, we could determine the specific error that
      ' occurred and take actions based upon this information.  Errors will occur
      ' if you attempt to write to an input port, pass an invalid card handle, or
      ' specify a port that does not exist on the card. A returned value of 0
      ' indicates success.
      'Note that it is usually not necessary to check for errors after every I/O
      ' operation. We are simply demonstrating the general technique in case you
      ' need to do so.
      MsgBox "Error # " & Result & " occurred."
   End If
  
  'Display the data from the input port
   lblInValue = Value

End Sub

Private Sub btnWrite_Click()
  'Dimension variables
   Dim Value As Long            'Holds the value to write to the output port
   Dim Result As Long           'Holds the return value of the function
   
  'Extract the value to write to the output port
   Value = Val([txtOutValue])
   
  'Write the value to the output port
   Result = we_OutputValue(hCard, 1, Value)
  
  'Check if any errors occurred
   If Result < 0 Then
      'Error handling code goes here; we will just display the error number if an
      ' error occurs.  If we wanted to, we could determine the specific error that
      ' occurred and take actions based upon this information.  Errors will occur
      ' if you attempt to write to an input port, pass an invalid card handle, or
      ' specify a port that does not exist on the card. A returned value of 0
      ' indicates success.
      'Note that it is usually not necessary to check for errors after every I/O
      ' operation. We are simply demonstrating the general technique in case you
      ' need to do so.
      MsgBox "Error # " & Result & " occurred."
   End If
End Sub

Private Sub Form_Load()
   'Dimension variables
    'List of form-level variables (for information only)
     'hCard holds the handle of the CRD155B
    'Local variables
     Dim ErrMsg As String       'holds error message string
     Dim BaseAddress As Long    'holds the base address of the CRD155B I/O card
    
   '*************************************************
   'General Procedure:
   '    1.) Open the card and get a handle to identify it
   '    2.) Configure the card so that Port 1 is OUTPUT and Port 2 is INPUT
   '    3.) The card is now ready to output and input data
   '*************************************************
   
   'Before opening and configuring the I/O card, issue a warning stating that
   ' one of the ports will be configured as an OUPUT port.  Give the user a
   ' chance to Cancel the program before the configuration takes place.  This
   ' can help prevent data conflicts (bus contention) if the user currently
   ' has a device connected to Port 1.
   '**NOTE: This type of warning is not typically issued in a finished application.
   ' However, it is a good idea in something like sample code, since the user
   ' may run the program without really knowing what it does.  If he currently
   ' has a data source connected to Port 1, there could be bus contention.
   
   If MsgBox("WARNING:  Port 1 is about to be configured as an OUTPUT port." & _
            vbCrLf & "Please remove any device which could cause a data conflict, or else " & _
            vbCrLf & "Cancel the program execution.", vbExclamation + vbOKCancel) = vbCancel Then
      'User hit 'Cancel' button --> END the program
      End
   End If
   
   '************************************************
   'Open the CRD155B card and get the handle
   'Assume the card is located at base address 384 decimal
    BaseAddress = 384
    hCard = we_OpenCard(WECRD_155B, BaseAddress)
    
   'Check if card was opened without errors
    If hCard < 0 Then
       'Since the return value is < 0, we have an error.  We can also test to
       'see which specific error occurred. Note that a returned value of 0
       'indicates success.
        Select Case hCard
           Case WECRD_CARD_NOTFOUND
              'Can't find the card at the specified address --> define error msg
               ErrMsg = "CRD155B does not exist at the specified base address." & vbCrLf & _
                        "Please be sure the card's base address is set to " & BaseAddress
           Case Else
             'Some other error occurred --> define error msg
              ErrMsg = "Error occurred while attempting to open the CRD155B card."
        End Select
       'Display the error message
        MsgBox ErrMsg
       'End the Program
        End
    End If
    
   '************************************************
   'Configure the CRD155B card
    'Configure Port 1 as OUTPUT
     we_ConfigureCard hCard, 1, WECRD_OUTPUT
    'Configure Port 2 as INPUT
     we_ConfigureCard hCard, 2, WECRD_INPUT
    'Configure Port 3 as INPUT (although we don't actually use it)
     we_ConfigureCard hCard, 3, WECRD_INPUT
     
   
End Sub
