Module WeCrd
    '   This file provides the function declarations, constants, and error
    '   codes for Winford Engineering's I/O Card API.
    '
    '    Winford Engineering
    '    www.winfordeng.com
    Public Declare Function we_OpenCard Lib "wecrd.dll" (ByVal Model As Integer, ByVal BaseAddr As Integer) As Integer
    Public Declare Function we_ConfigureCard Lib "wecrd.dll" (ByVal Handle As Integer, ByVal Port As Integer, ByVal Mode As Integer) As Integer
    Public Declare Function we_OutputValue Lib "wecrd.dll" (ByVal Handle As Integer, ByVal Port As Integer, ByVal Value As Integer) As Integer
    Public Declare Function we_InputValue Lib "wecrd.dll" (ByVal Handle As Integer, ByVal Port As Integer, ByRef Value As Integer) As Integer
    Public Declare Function we_ReadBack Lib "wecrd.dll" (ByVal Handle As Integer, ByVal Port As Integer, ByRef Value As Integer) As Integer
    Public Declare Function we_CloseCard Lib "wecrd.dll" (ByVal Handle As Integer) As Integer
    Public Declare Function we_CloseAllCards Lib "wecrd.dll" (ByVal Reserved As Integer) As Integer

    Public Const WECRD_155B As Integer = 10   'the WECRD155B has ports 1 through 3

    'Various Constants
    Public Const WECRD_INPUT As Integer = 1    'port in input state
    Public Const WECRD_OUTPUT As Integer = 2   'port in output state

    'Error Codes

    Public Const WECRD_SUCCESS As Integer = 0
    Public Const WECRD_GENERAL_ERROR As Integer = -1 'Miscellaneous error
    Public Const WECRD_IO_ERROR As Integer = -10     'unable to read or write a port. In Linux, this may result from improper permissions on /dev/port
    Public Const WECRD_INVALID_HANDLE As Integer = -101 'No card is currently open with that handle
    Public Const WECRD_INVALID_MODEL As Integer = -102      'Model was invalid (doesn't exist)
    Public Const WECRD_INVALID_ADDRESS As Integer = -103    'Address invalid for the specified model
    Public Const WECRD_INVALID_PORT As Integer = -104         'Port specified is invalid for the card model
    Public Const WECRD_INVALID_PORTMODE As Integer = -105     'There is no such mode for that port, or that mode is currently unavailable
    Public Const WECRD_INVALID_PORTVALUE As Integer = -106    'Value passed is out of valid range
    Public Const WECRD_ADDRESS_CONFLICT As Integer = -114     'Desired address conflicts with an opened card (Card may have been previously opened and never closed)
    Public Const WECRD_CARD_NOTFOUND As Integer = -115        'Card doesn't seem to exist at that address
    Public Const WECRD_WRONG_PORTMODE As Integer = -150       'Card is not in the correct mode.
    ' (such as calling OutputValue when the port is in input mode)

End Module
